
//Title:        Talker
//Version:
//Copyright:    Copyright (c) 1999
//Author:       Pinelli & Pucciarelli
//Company:      P&P
//Description:

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import javax.swing.*;

public class Chatter extends JFrame implements Runnable {

  /**
  * Socket di comunicazione fra i due Client
  */
  private Socket socket;
  /**
  * Utente remoto in comunicazione tramite il Chatter
  */
  private User remoteUser;
  /**
  * Nick in uso
  */
  private String myNick;
  /**
  * Thread che gestisce il flusso di messaggi in ingresso
  */
  private chatterReceiver in;
  /**
  *  Thread che gestisce il flusso di messaggi in uscita
  */
  private chatterSender out;
  /**
   *  Client padre del Chatter
   */
  private Client clientPadre;
  /**
   * Stato della connessione con il chatter remoto
   */
  private boolean Connected=false;
  private boolean Painted=false;

  GridLayout gridLayout1 = new GridLayout();
  TextArea textArea1 = new TextArea();
  Panel panel1 = new Panel();
  GridLayout gridLayout2 = new GridLayout();
  Panel panel2 = new Panel();
  TextField textField1 = new TextField();




  /**
  * Costruttore usato da clientListener quando riceve
  * una richiesta di comunicazione
  */

  public Chatter(Socket s,Client client,User userRemoto){

    try{
      remoteUser=userRemoto;
      myNick=client.myUser.getNick();
      clientPadre=client;
      socket=s;
      // importante l'ordine in-out
      in=new chatterReceiver(this,new ObjectInputStream(socket.getInputStream()));
      System.out.println("Canale in inizializzato");
      out=new chatterSender(this,new ObjectOutputStream(socket.getOutputStream()));
      System.out.println("canale out inizializzato");
    }
    catch(Exception e){
      //gestione eccezione socket
      textArea1.append("Eccezione socket da costruttore 1");
      e.printStackTrace();
    }
  }

    /**
  *Costruttore usato da Client per inviare
  *una richiesta di comunicazione
  */
  public Chatter(User userRemoto,Client client){

      remoteUser=userRemoto;
      myNick=client.myUser.getNick();
      clientPadre=client;
      try{
        socket=new Socket(userRemoto.getIndIP(),userRemoto.getClientListenerPort().intValue());
        // importante l'ordine  out-in
        out=new chatterSender(this,new ObjectOutputStream(socket.getOutputStream()));
        in=new chatterReceiver(this,new ObjectInputStream(socket.getInputStream()));
        Connected=true;
      }catch(IOException e){
        textArea1.append("Impossibile contattare l'utente");
      }
  }

  public void sendMsg(String s){
    out.send(s);
  }

  public void run(){

      try{
        jbInit();
      }catch(Exception e){
        textArea1.append("Impossibile inizializzare ambiente grafico");
      }
      this.setTitle(remoteUser.getNick()+" - "+remoteUser.getIndIP());
      setSize(300,200);
      show();
    in.start();
    out.start();
  }

  public void riceviMsg(String s){
    this.textArea1.append("<"+remoteUser.getNick()+">"+s+"\n");
  }

  public Chatter() {
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

    /**
  * Inizializzazione dell'interfaccia grafica
  */
  private void jbInit() throws Exception {

    gridLayout1.setRows(2);
    this.getContentPane().setLayout(gridLayout1);
    panel1.setLayout(gridLayout2);
    gridLayout2.setRows(4);
    textField1.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        textField1_actionPerformed(e);
      }
    });
    textArea1.setBackground(Color.white);
    textArea1.setEditable(false);
    this.addWindowListener(new java.awt.event.WindowAdapter() {

      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }
    });
    this.getContentPane().add(textArea1, null);
    this.getContentPane().add(panel1, null);
    panel1.add(panel2, null);
    panel1.add(textField1, null);
  }

  void textField1_actionPerformed(ActionEvent e) {
    this.sendMsg(textField1.getText());
    textArea1.append("<"+myNick+">"+textField1.getText()+"\n");
    textField1.setText("");
  }

  void this_windowClosing(WindowEvent e) {
    clientPadre.listaChatter.removeUser(remoteUser);
    in.stop();
    out.stop();
  }
  public boolean isConnected(){
    return Connected;
  }
}

