
//Title:        Talker
//Version:
//Copyright:    Copyright (c) 1999
//Author:       Pinelli & Pucciarelli
//Company:      P&P
//Description:
import java.net.*;
import java.io.*;

public class Client {

  private String ipServer;
  //private String Nick;
  private ObjectInputStream in;
  private ObjectOutputStream out;
  private Socket socket;
  public UserList ListaUtenti,listaChatter;   //public???????
  public User myUser;
  private clientListener listenclient;
  private serverListener listenserver;
  graphInterface talkui;
  private boolean Connected=false;

  public Client(graphInterface ui,String ipSrv) {
    myUser=new User();
    ipServer=ipSrv;
    talkui=ui;
    listaChatter=new UserList();
  }

  public void connect(){
    String str;
    int i;
  if(Connected){
    sendMsg("/Connect");
    scriviMsg("Inviato /Connect");
    str=(String)receiveMsg();
    scriviMsg(str);
    if(str.equals("OK")){
      scriviMsg(myUser.getNick());
      //sendMsg(myUser);
      //sendMsg(myUser.getIndIP());
      sendMsg(myUser.getNick());
      sendMsg(myUser.getPassword());
      sendMsg(myUser.getServerListenerPort().toString());
      sendMsg(myUser.getClientListenerPort().toString());
      scriviMsg("Inviato user "+myUser.getNick());
      str=(String)receiveMsg();
      scriviMsg(str);
      if(str.equals("OK")){
        sendMsg("/UserList");
        ListaUtenti=(UserList)receiveMsg();
        for(i=0;i<ListaUtenti.size();i++)
          //orderListAdd(((User)(ListaUtenti.get(i))));
          talkui.addList(((User)(ListaUtenti.get(i))));
      }
    } //fine if ok
    else  scriviMsg(str);
  }
  else{
    esegui();
    if(Connected) connect();
    else scriviMsg("Impossibile connettersi al server");
  }
  } //fine connect

  public void scriviMsg(String s){
    talkui.scriviMsg(s);
  }

  public Object receiveMsg(){
    try{
      return in.readObject();
    }catch(Exception e)
    {
      scriviMsg("Caduta connessione con il server");
      Connected=false;
      return null;
    }
  }

  public void startChat(String nickUserRemoto){
    User userRemoto;

    userRemoto=ListaUtenti.findNick(nickUserRemoto);
    if((listaChatter.isIn(userRemoto)<0) && (!(userRemoto.getNick()).equals(myUser.getNick()))){
      listaChatter.addUser(userRemoto);
      Chatter c1=new Chatter(userRemoto,this);
      if(c1.isConnected()){
        Thread t=new Thread(c1);
        t.start();
      }
      else{
        scriviMsg("Utente " + userRemoto.getNick() + " non raggiungibile");
        talkui.removeList(userRemoto);
      }
    }
    else scriviMsg("L' utente selezionato  gi attivo");
  }

  public void sendMsg(Object o){
    try{
      out.writeObject(o);
    } catch(IOException e)
    {
      scriviMsg("Caduta connessione con il server");
      Connected=false;
    }
  }

  public void esegui(){
    String str;
    int i;

    try{
      listenclient=new clientListener(this);
      myUser.setClientListenerPort(listenclient.getListenerPort());
      listenserver=new serverListener(this);
      myUser.setServerListenerPort(listenserver.getListenerPort());
      //scriviMsg("clientlistener: "+listenclient.toString());
      socket= new Socket(ipServer,9999);
      this.scriviMsg("Socket: "+socket);
      out=new ObjectOutputStream(socket.getOutputStream());
      in=new ObjectInputStream(socket.getInputStream());
      Connected=true;
    } //fine try
    catch(IOException e){
      scriviMsg("Inizializzazione socket non riuscita");
      listenclient.stop();
      listenserver.stop();
    } //fine catch
  } //fine esegui

  public void Reconnect(String indIP){
  String str;

    try{
      ipServer=indIP;
      socket= new Socket(ipServer,9999);
      scriviMsg("Riavviata socket: "+socket);
      out=new ObjectOutputStream(socket.getOutputStream());
      in=new ObjectInputStream(socket.getInputStream());
       }catch(IOException e){
          scriviMsg("Reinizializzazione socket non riuscita");
          listenclient.stop();
          listenserver.stop();
        } //fine catch
      Connected=true;
      sendMsg("/Reconnect");
      scriviMsg("Inviato Reconnect");
      str=(String)receiveMsg();
      scriviMsg(str);
      if(str.equals("OK")){
        scriviMsg(myUser.getNick());
        //sendMsg(myUser);
        //sendMsg(myUser.getIndIP());
        sendMsg(myUser.getNick());
        sendMsg(myUser.getPassword());
        sendMsg(myUser.getServerListenerPort().toString());
        sendMsg(myUser.getClientListenerPort().toString());
        scriviMsg("Reinviato user "+myUser.getNick());
        //str=(String)receiveMsg();
        //scriviMsg(str);
       }
      }
      }