
//Title:        Talker
//Version:
//Copyright:    Copyright (c) 1999
//Author:       Pinelli & Pucciarelli
//Company:      P&P
//Description:
import java.awt.*;
import java.net.*;
import java.io.*;

public class Server {

  ServerSocket serversocket;
  Socket sockMaster;
  Socket socket;
  public UserList ListaUtenti;  // public??????
  graphInterface talkui;
  boolean Master,SlavePresent=false,Avviato=false;
  String ipMaster;
  User Slave;
  ObjectInputStream inMaster;
  ObjectOutputStream outMaster;
  comMasterSlave comMS;
  /**
  *Crea un Server in modalit Master
  */
  public Server(graphInterface gui){
    talkui=gui;
    Master=true;
    ipMaster="";
  }

  /**
  * Crea un Server specificando la modalit Master/Slave
  * e l'eventuale indirizzo IP del Server Master
  */
  public Server (graphInterface gui,boolean master,String ipserver){
    talkui=gui;
    Master=master;
    ipMaster=ipserver;
  }


  public void avvia(){
  if(!Avviato){
    ListaUtenti=new UserList();
    if(Master){
    try{
      serversocket=new ServerSocket(9999);
      scriviMsg("Server Avviato: "+serversocket);
      Avviato=true;
      try{
        while(true){
          socket=serversocket.accept();
          scriviMsg("Accettata connessione: "+socket);
          try{ //try 3
            new serveOneClient(socket,this);
          }//fine try3
          catch(IOException e) {
            talkui.scriviMsg("Errore avvio serveOneclient");
          }//fine catch 3
        }//fine while
      }
      catch (IOException e){
        talkui.scriviMsg("Errore di Accept() della Serversocket");
      }
    }catch(IOException e){
      talkui.scriviMsg("Errore nell'avvio della ServerSocket");
    }
    }// fine if(Master)
    else{ // Server Slave
    String msg;
    int i;
    Integer portSlave;
      try{
        sockMaster=new Socket(ipMaster,9999);
        outMaster=new ObjectOutputStream(sockMaster.getOutputStream());
        inMaster=new ObjectInputStream(sockMaster.getInputStream());
        scriviMsg("Server Avviato: "+sockMaster);
        send("/AddSlave");
        msg=(String)receive();
        if(msg.equals("OK")){
          masterListener listenMaster=new masterListener(this);
          portSlave=listenMaster.getListenerPort();
          send(portSlave);
          msg=(String)receive();
          if(msg.equals("OK")){
            send("/UserList");
            ListaUtenti=(UserList)receive();
            for(i=0;i<ListaUtenti.size();i++)
            talkui.addList(((User)(ListaUtenti.get(i))));
          }
        }
        comMasterSlave comMS=new comMasterSlave(inMaster,this);
      }catch(IOException e){
        talkui.scriviMsg("Errore di connessione al Server Master");
      }
    }// fine else
  }// fine if(!Avviato)
  }

  public void mulcastNewUser(User newUser){
    int i;
    User u;
    synchronized(ListaUtenti){
    for(i=0;i<ListaUtenti.size();i++){
      u=(User)ListaUtenti.get(i);
      if(!(u.getNick()).equals(newUser.getNick())){//Non devo il mandare il newUser al newUser
        try{// try 1
          Socket sock=new Socket(((User)(ListaUtenti.get(i))).getIndIP(),
            ((User)(ListaUtenti.get(i))).getServerListenerPort().intValue());
          ObjectOutputStream out=new ObjectOutputStream(sock.getOutputStream());
          ObjectInputStream in=new ObjectInputStream(sock.getInputStream());
          try{//try 2
            out.writeObject("Adduser");
            String str=(String)in.readObject();
            if(str.equals("OK")){
            	out.writeObject(newUser);
            	str=(String)in.readObject();
            }
          }catch(IOException e){}
          try{ sock.close();
          }catch(Exception e){
            scriviMsg("Impossibile chiudere socket ");
          }// fine try 2
        }catch(Exception e){
          scriviMsg("Errore socket "+ u.getNick());
        }// fine try 1
      }// fine if
    }//fine for
    }//fine synchronized
    if(SlavePresent){
      try{// try 1
          Socket sock=new Socket(Slave.getIndIP(),
            Slave.getServerListenerPort().intValue());
          ObjectOutputStream out=new ObjectOutputStream(sock.getOutputStream());
          ObjectInputStream in=new ObjectInputStream(sock.getInputStream());
          try{//try 2
            out.writeObject("Adduser");
            String str=(String)in.readObject();
            if(str.equals("OK")){
            	out.writeObject(newUser);
            	str=(String)in.readObject();
            }
          }catch(IOException e){}
          try{ sock.close();
          }catch(Exception e){
            scriviMsg("Impossibile chiudere socket ");
          }// fine try 2
        }catch(Exception e){
          scriviMsg("Errore socket ");
        }// fine try 1
    }// fine if(SlavePresent)
  }

  public void mulcastRemoveUser(User newUser){
    int i;
    User u;
    synchronized(ListaUtenti){
    for(i=0;i<ListaUtenti.size();i++){
      u=(User)ListaUtenti.get(i);
      if(!(u.getNick()).equals(newUser.getNick())){
        try{
          Socket sock=new Socket(((User)(ListaUtenti.get(i))).getIndIP(),
            ((User)(ListaUtenti.get(i))).getServerListenerPort().intValue());
          ObjectOutputStream out=new ObjectOutputStream(sock.getOutputStream());
          ObjectInputStream in=new ObjectInputStream(sock.getInputStream());
          try{
            out.writeObject("Removeuser");
            String str=(String)in.readObject();
            if(str.equals("OK")){
            	out.writeObject(newUser);
            	str=(String)in.readObject();
            }
          }catch(IOException e){}
          try{ sock.close();
          }catch(Exception e){
            scriviMsg("Impossibile chiudere socket ");
          }
        }catch(Exception e){
          scriviMsg("Errore socket "+ u.getNick());
        }
      }
    }
    }
    if(SlavePresent){
      try{// try 1
          Socket sock=new Socket(Slave.getIndIP(),
            Slave.getServerListenerPort().intValue());
          ObjectOutputStream out=new ObjectOutputStream(sock.getOutputStream());
          ObjectInputStream in=new ObjectInputStream(sock.getInputStream());
          try{//try 2
            out.writeObject("Removeuser");
            String str=(String)in.readObject();
            if(str.equals("OK")){
            	out.writeObject(newUser);
            	str=(String)in.readObject();
            }
          }catch(IOException e){}
          try{ sock.close();
          }catch(Exception e){
            scriviMsg("Impossibile chiudere socket ");
          }// fine try 2
        }catch(Exception e){
          scriviMsg("Errore socket ");
        }// fine try 1
    }// fine if(SlavePresent)
  }

  public void removeUser(User user){
  	int i;
  	i=ListaUtenti.removeUser(user);
  	if(i!=-1){
  	  if(Master)mulcastRemoveUser(user);
  	  //list1.remove(user.getNick());
          talkui.removeList(user);
  	}
  }

  public void scriviMsg(String s){
    talkui.scriviMsg(s);
  }

  public String addUser(User user){
   String s;
   s=ListaUtenti.addUser(user);
   if(s.equals("OK"))
    talkui.addList(user) ;
   return s;
  }

  public void SetSlavePresent(boolean present){
   SlavePresent=present;
  }

  public void addSlave(User user){
   Slave=user;
   SlavePresent=true;
  }

  public void send(Object o){
    try{
      outMaster.writeObject(o);
    }catch(IOException e){
      scriviMsg("Errore Send - Caduta connessione server");
    }
  }

  public Object receive(){
    try{
      return inMaster.readObject();
    }catch(Exception e)
    {
      scriviMsg("Caduta connessione con il server da receive");
      return null;
    }
  }

  public void setMaster(){
  Master=true;
  SlavePresent=false;
  ipMaster="";
  }

  public void reStart(){


  setMaster();
  try{
      serversocket=new ServerSocket(9999);
      scriviMsg("Server Riavviato: "+serversocket);
      Avviato=true;
      mulcastReconnect();
      try{
        while(true){
          socket=serversocket.accept();
          scriviMsg("Accettata connessione: "+socket);
          try{ //try 3
            new serveOneClient(socket,this);
          }//fine try3
          catch(IOException e) {
            talkui.scriviMsg("Errore avvio serveOneclient");
          }//fine catch 3
        }//fine while
      }
      catch (IOException e){
        talkui.scriviMsg("Errore di Accept() della Serversocket");
      }
    }catch(IOException e){
      talkui.scriviMsg("Errore nell'avvio della ServerSocket");
    }
    }// fine if(Master)

  public void  mulcastReconnect(){
    int i;
    User u;
    UserList listaclientmorti=new UserList(); //client caduti dopo master prima di slave

    synchronized(ListaUtenti){
    for(i=0;i<ListaUtenti.size();i++){
      u=(User)ListaUtenti.get(i);
        try{// try 1
          Socket sock=new Socket(((User)(ListaUtenti.get(i))).getIndIP(),
            ((User)(ListaUtenti.get(i))).getServerListenerPort().intValue());
          ObjectOutputStream out=new ObjectOutputStream(sock.getOutputStream());
          ObjectInputStream in=new ObjectInputStream(sock.getInputStream());
          try{//try 2
            out.writeObject("Reconnect");
            //String str=(String)in.readObject();
          }catch(IOException e){}
          try{ sock.close();
          }catch(Exception e){
            scriviMsg("Impossibile chiudere socket ");
          }// fine try 2
        }catch(Exception e){
          listaclientmorti.addUser(u);
          scriviMsg("Impossibile contattare utente "+ u.getNick());
        }// fine try 1
    }// fine for
    }//fine synchronized
    if(!listaclientmorti.isEmpty()){
      for(i=0;i<listaclientmorti.size();i++){
       ListaUtenti.removeUser((User) listaclientmorti.get(i));
       talkui.removeList((User) listaclientmorti.get(i));
      }
    }
  }//fine mulcastReconnect
}