
//Title:        Talker
//Version:      
//Copyright:    Copyright (c) 1999
//Author:       Pinelli & Pucciarelli
//Company:      P&P
//Description:  

import java.util.*;
import java.io.*;

public class UserList extends ArrayList implements Serializable  {

  public UserList() {
  }

  int isIn (User user){
    return this.indexOf(user);
  }

  int isInNick(String nick){
    int i;
    for(i=0;i<this.size();i++)
      if(((User)this.get(i)).isEqualNick(nick)) return i;
    return -1;
  }

  int isInIP(String indIP){
    int i;
    for(i=0;i<this.size();i++)
      if(((User)this.get(i)).isEqualIP(indIP)) return i;
    return -1;
  }

  public User findNick(String nick){
    int i;
    i=isInNick(nick);
    if(i==-1) return null;
    return ((User)(this.get(i)));
  }

  public User findIP(String indIP){
    int i;
    i=isInIP(indIP);
    if(i==-1) return null;
    return ((User)(this.get(i)));
  }

  public synchronized String addUser(User user){
    if(isInNick(user.getNick())!=-1)
      return "Nick_in_use";
    //il seguente controllo  da evitare in prove su pc locale
    if(isInIP(user.getIndIP())!=-1)
      return "AlreadyConnected";
    this.add(user);
    return "OK";
  }

  public synchronized int removeUser(User user){
  	int i;
  	i=isInNick(user.getNick());
  	if(i!=-1) this.remove(i);
  	return i;	
  }

}  
