
//Title:        Talker
//Version:
//Copyright:    Copyright (c) 1999
//Author:       Pinelli & Pucciarelli
//Company:      P&P
//Description:


import java.net.*;
import java.io.*;
import java.util.*;

public class serveOneClient extends Thread {
  /**
  * Socket di comunicazione con il Client
  */
  private Socket socket;
  /**
  * Server che ha generato il Thread di ascolto per il Client
  */
  private Server srvPadre;
  /**
  * Stream di Input del Thread
  */
  private ObjectInputStream in;
  /**
  * Stream di Output del Thread
  */
  private ObjectOutputStream out;
  /**
  * Utente Client
  */
  private User newUser,srvSlave;

  boolean Slave=false;

    /**
  * Costruttore che inizializza le variabili membro
  * e manda in esescuzione il thread
  */
  public serveOneClient(Socket s,Server srv)throws IOException {
    socket=s;
    srvPadre=srv;
    in=new ObjectInputStream(socket.getInputStream());
    out=new ObjectOutputStream(socket.getOutputStream());
    start();
  }

    /**
  * metodo per scrivere messaggi su out socket
  */
  public void sendMsg(Object o){

    try{
      out.writeObject(o);
    } catch(IOException e){
      srvPadre.scriviMsg("Caduta connessione in fase d'invio all'Utente: "+newUser.getNick());
      srvPadre.scriviMsg("Errore: " + e.toString());
    }
  }

  /**
  *metodo per ricevere i messaggi da in socket
  */
  public Object receiveMsg(){

    try{
      return in.readObject();
    }catch(Exception e){
      if(!Slave){
        /*if(newUser==NULL)
        {
         newUser=new User;
         newUser.setIndIP(socket.getInetAddress());
          */
        srvPadre.scriviMsg("Caduta connessione da receive-Utente: "+newUser.getNick());
        srvPadre.removeUser(newUser);
      }else{
        srvPadre.scriviMsg("Caduta connessione da Server Slave");
        srvPadre.SetSlavePresent(false);
      }
      return null;
    }
  }

  /**
  * Metodo per l'esecuzione del Thread.
  * Realizza un ciclo di ascolto delle richieste del Client
  */
  public void run(){

  StringTokenizer st;
  String token;
  String str, ind, nick, pwd;

    while(true){
      int i;
      str=(String)receiveMsg();
      if (str.charAt(0)=='/'){
        //La stringa ricevuta  un comando
        if(str.equals("/Connect")){
          srvPadre.scriviMsg("Ricevuta Connect");
          sendMsg("OK");
          //Ricevi i dati dello User
          //ind=((String)receiveMsg());
          //srvPadre.scriviMsg(ind);
          ind=socket.getInetAddress().getHostAddress();
          nick=((String)receiveMsg());
          srvPadre.scriviMsg(nick);
          pwd=((String)receiveMsg());
          srvPadre.scriviMsg(pwd);
          Integer indportsrv=new Integer((String)receiveMsg());
          srvPadre.scriviMsg(indportsrv.toString());
          Integer indportcli=new Integer((String)receiveMsg());
          srvPadre.scriviMsg(indportcli.toString());
          User user=new User(nick,ind,pwd,indportsrv,indportcli);
          newUser=user;
          srvPadre.scriviMsg("User ricevuto " + newUser.getNick());
          newUser.setIndIP(socket.getInetAddress().getHostAddress());
          str=srvPadre.addUser(newUser);
          srvPadre.scriviMsg(str);
          //Possibili tre messaggi:
          // OK - Nick_in_use - AlreadyConnected
          sendMsg(str);
          if(str.equals("OK")) {
            srvPadre.scriviMsg("Accettato nuovo utente " + newUser.getNick());
            srvPadre.mulcastNewUser(newUser);
          }
        } //fine if /Connect
        else{ //else 1
          if(str.equals("/UserList")){
            sendMsg(srvPadre.ListaUtenti);
          }//fine if /UserList
          else{ //else 2
            if(str.equals("/AddSlave")){
            Integer indportcli,indportsrv;
              srvPadre.scriviMsg("Accettata connessione da server slave");
              sendMsg("OK");
              indportsrv=(Integer)receiveMsg();
              sendMsg("OK");
              indportcli=new Integer(0);
              User userSlave=new User("Slave",socket.getInetAddress().getHostAddress(),"",indportsrv,indportcli);
              srvPadre.addSlave(userSlave);
              srvPadre.scriviMsg("Slave Accettato");
              Slave=true;
            } //fine if /AddSlave
           // fine else 2
          else
          {
           if(str.equals("/Reconnect"))
           {
             sendMsg("OK");
             //Ricevi i dati dello User
             //ind=((String)receiveMsg());
             //srvPadre.scriviMsg(ind);
             ind=socket.getInetAddress().getHostAddress();
             nick=((String)receiveMsg());
             srvPadre.scriviMsg(nick);
             pwd=((String)receiveMsg());
             srvPadre.scriviMsg(pwd);
             Integer indportsrv=new Integer((String)receiveMsg());
             srvPadre.scriviMsg(indportsrv.toString());
             Integer indportcli=new Integer((String)receiveMsg());
             srvPadre.scriviMsg(indportcli.toString());
             User user=new User(nick,ind,pwd,indportsrv,indportcli);
             newUser=user;
             srvPadre.scriviMsg("User ricevuto " + newUser.getNick());
             newUser.setIndIP(socket.getInetAddress().getHostAddress());
             
            }
        } //fine else 1
      }//fine if comando
       }
       }
      else srvPadre.scriviMsg(newUser.getNick() + ">" + str);
    } //fine while
  }//fine run


}
